> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://fyno.io/docs/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://fyno.io/docs/_mcp/server.

# Batch Update User Properties

POST https://api.fyno.io/v1/{WSID}/{version}/profiles/properties/batch
Content-Type: application/json

This API enables you to modify user properties of your users listed in your [User Profiles](../user-profiles-overview) in bulk:
- [Update User Properties](./update-user-property) - `$set`
- [Set Unset Properties](./set-an-unset-property) - `$once`
- [Increment/Decrement Numeric Properties](./increment-decrement-numeric-property) - `$add`
- [Append Values to List](./append-values-to-list) - `$append`
- [Remove Values From List](./remove-value-from-list) - `$remove`
- [Unset User Properties](./unset-user-property) - `$unset`

**Please refer to function specific API documentation for [\$set](./update-user-property), [\$once](./set-an-unset-property), [\$add](./increment-decrement-numeric-property), [\$append](./append-values-to-list), [\$remove](./remove-value-from-list), [\$unset](./unset-user-property) before using this API.**

**Note:** The user properties in User Profiles can be used to filter your users for creating [user cohorts](../creating-cohorts) and [campaigns](../campaign_creation#creating-a-campaign-using-cohort).


Reference: https://fyno.io/docs/api-reference/batch-update-user-properties

## Authentication

- `Authorization` header (bearer token, required) — Enter your API Key. If you don't have it already, you can create one from the API Keys page within your Fyno account

## Request

### Path parameters

- `WSID` (string, required) — Enter your workspace ID. You can obtain this value from the API Keys page within your Fyno account.
- `version` (string, required) — Specify the version for which you would like to update the user property.

### Body (application/json)

This endpoint expects an user_property_bulk.

- `batch` (list of UserPropertyBulkBatchItems, required) — Enter an array of objects with `distinct_id` and `action` to perform on the user properties

## Response

### 202

Request has been accepted and will be processed asynchronously.

- `request_id` (string, required)
- `batch` (list of WsidVersionProfilesPropertiesBatchPostResponsesContentApplicationJsonSchemaBatchItems, required)

## Errors

### 400 Bad Request Error

$unset object is empty

- `_message` (string, required)
- `status` (string, required)

### 401 Unauthorized Error

API Key or Workspace ID is invalid. User is unauthorised.

- `_message` (string, required)
- `status` (string, required)

## Types

### UserPropertyBulkBatchItems

- `distinct_id` (string, required) — Enter the distinct ID that you use to identify the recipient.
- `action` (UserPropertyBulkBatchItemsAction, required)

### WsidVersionProfilesPropertiesBatchPostResponsesContentApplicationJsonSchemaBatchItems

- `$set` (string, optional)
- `$once` (string, optional)
- `$add` (string, optional)
- `$append` (string, optional)
- `$remove` (string, optional)
- `$unset` (string, optional)

### UserPropertyBulkBatchItemsAction

- `$set` (map from string to SetUserPropertyFields, optional) — Enter the property name as JSON key and the value to set as JSON value
- `$once` (map from string to SetUserPropertyOnceFields, optional) — Enter the property name as JSON key and the value to set as JSON value
- `$add` (map from string to double, optional) — Enter the property name as JSON key and the numeric value to increment/decrement as JSON value
- `$append` (map from string to AppendToUserPropertyFields, optional) — Enter the property name as JSON key and the numeric or string value to append as JSON value
- `$remove` (map from string to RemoveFromUserPropertyListFields, optional) — Enter the property name as JSON key and the value to remove as JSON value
- `$unset` (list of string, optional) — Enter the property names to unset in an array

### SetUserPropertyFields

### SetUserPropertyOnceFields

### AppendToUserPropertyFields

### RemoveFromUserPropertyListFields

## Examples

**Request**

```json
{
  "batch": [
    {
      "distinct_id": "XXXXXXXX",
      "action": {}
    }
  ]
}
```

**Response**

```json
{
  "request_id": "XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX",
  "batch": [
    {
      "$set": "ok",
      "$once": "ok",
      "$add": "ok",
      "$append": "ok",
      "$remove": "ok",
      "$unset": "ok"
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.fyno.io/v1/FYXXXXXXXX/version/profiles/properties/batch"

payload = { "batch": [
        {
            "distinct_id": "XXXXXXXX",
            "action": {}
        }
    ] }
headers = {
    "Authorization": "Bearer <apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.fyno.io/v1/FYXXXXXXXX/version/profiles/properties/batch';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <apiKey>', 'Content-Type': 'application/json'},
  body: '{"batch":[{"distinct_id":"XXXXXXXX","action":{}}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.fyno.io/v1/FYXXXXXXXX/version/profiles/properties/batch"

	payload := strings.NewReader("{\n  \"batch\": [\n    {\n      \"distinct_id\": \"XXXXXXXX\",\n      \"action\": {}\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.fyno.io/v1/FYXXXXXXXX/version/profiles/properties/batch")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"batch\": [\n    {\n      \"distinct_id\": \"XXXXXXXX\",\n      \"action\": {}\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.fyno.io/v1/FYXXXXXXXX/version/profiles/properties/batch")
  .header("Authorization", "Bearer <apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"batch\": [\n    {\n      \"distinct_id\": \"XXXXXXXX\",\n      \"action\": {}\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.fyno.io/v1/FYXXXXXXXX/version/profiles/properties/batch', [
  'body' => '{
  "batch": [
    {
      "distinct_id": "XXXXXXXX",
      "action": {}
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.fyno.io/v1/FYXXXXXXXX/version/profiles/properties/batch");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"batch\": [\n    {\n      \"distinct_id\": \"XXXXXXXX\",\n      \"action\": {}\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <apiKey>",
  "Content-Type": "application/json"
]
let parameters = ["batch": [
    [
      "distinct_id": "XXXXXXXX",
      "action": []
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.fyno.io/v1/FYXXXXXXXX/version/profiles/properties/batch")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```